<?php

namespace Drupal\media_twig_tools\Services;

/**
 * Service description interface.
 */
interface BounceInterface {

  /**
   * Service ID.
   *
   * @const string
   */
  public const SERVICE_ID = 'media_twig_tools.bounce';

  /**
   * State id.
   *
   * @const string
   */
  public const STATE_ID = 'media_twig_tools.bounce';

  /**
   * Return the dirname.
   *
   * @return string
   *   The dirname.
   */
  public function getDirname(): string;

  /**
   * Set the dirname.
   *
   * @param string $dirname
   *   The dirname.
   */
  public function setDirname(string $dirname): void;

  /**
   * Add the bounce in config.
   *
   * @param string $path
   *   The path.
   */
  public function addBounce(string $path);

  /**
   * Return token from path.
   *
   * @param string $path
   *   The file path.
   *
   * @return string
   *   The path.
   */
  public function getTokenFromPath(string $path);

  /**
   * Check the bounce.
   *
   * @param string $path
   *   The file path.
   */
  public function checkBounce($path);

  /**
   * Return bounces.
   *
   * @return array|mixed
   *   The bounces.
   */
  public function getBounces();

  /**
   * Delete state.
   */
  public function cleanBounce();

}
