<?php

namespace Drupal\media_twig_tools\Services;

use Drupal\file\FileInterface;

/**
 * Service description.
 */
interface OversizeCheckerInterface {

  /**
   * Return settings without oversize rules.
   *
   * @param \Drupal\file\FileInterface|null $file
   *   The file.
   * @param array $settings
   *   The settings.
   *
   * @return array
   *   The filtered settings.
   */
  public function getOversizeFilteredSettings(FileInterface $file = NULL, array $settings = []);

  /**
   * Check if rule is oversize.
   *
   * @param array $rule
   *   The rule data.
   * @param array $original_dimension
   *   The original dimension.
   *
   * @return bool
   *   True if oversize.
   */
  public function isRuleOversize(array $rule, array $original_dimension);

}
